
#property show_inputs

#include <stdlib.mqh>
#include <stderror.mqh>
#include <WinUser32.mqh>

#define  CHART_CMD_UPDATE_DATA            33324

#define OK 0
#define Err 1 

int rc;
int FileHandle = -1;
int FilePointer;
int DBVersion = 400;
int DummyUnused[13];

string SymbolName = "Test";
string FileName;
string CopyrightStr = "";

datetime LastCandleTime;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
  
   FileName =  SymbolName + Period() + ".hst";  
   FileHandle = FileOpenHistory(FileName, FILE_BIN|FILE_WRITE);   
   
   if (FileHandle < 0) 
      {
         Alert(": Cannot create ", FileName);
         return (Err);
      }
    
   FileWriteInteger(FileHandle, DBVersion, LONG_VALUE);           // db version
   FileWriteString(FileHandle, CopyrightStr, 64);                 // copyright
   FileWriteString(FileHandle, SymbolName, 12);                   // Symbol
   FileWriteInteger(FileHandle, Period(), LONG_VALUE);            // TimeFrame
   FileWriteInteger(FileHandle, Digits, LONG_VALUE);              // digits
   FileWriteInteger(FileHandle, 0, LONG_VALUE);                   // time db cration
   FileWriteInteger(FileHandle, 0, LONG_VALUE);                   // last synch 
   FileWriteArray(FileHandle, DummyUnused, 0, 13);                // unused
   FileFlush(FileHandle);
   FilePointer = FileTell(FileHandle);
   UpdateChartWindow();
    
   while (!IsStopped()) 
      if (RefreshRates()) 
         {
            FileSeek(FileHandle, FilePointer, SEEK_SET);

            FileWriteInteger(FileHandle, TimeCurrent(), LONG_VALUE);    
            FileWriteDouble(FileHandle, Open[0], DOUBLE_VALUE);
            FileWriteDouble(FileHandle, Low[0], DOUBLE_VALUE);
            FileWriteDouble(FileHandle, High[0], DOUBLE_VALUE);
            FileWriteDouble(FileHandle, Close[0], DOUBLE_VALUE);
            FileWriteDouble(FileHandle, Volume[0], DOUBLE_VALUE);
            FileFlush(FileHandle);
            UpdateChartWindow();
                        
            if (LastCandleTime != Time[0])
               {
                  LastCandleTime = Time[0];  
                  FilePointer = FileTell(FileHandle);
               }
         }
          
      else Sleep(100);

   return (0);
}
      
//----------------------------------------------------------------------------------- 
//-----------------------------------------------------------------------------------
int UpdateChartWindow()
{
   static int WinHandle = 0;

   if(WinHandle == 0) 
      WinHandle = WindowHandle(Symbol(), Period());

   if(WinHandle!= 0) {
      if (IsDllsAllowed() == false)    //DLL calls must be allowed
      {
         Alert("UpdateChartWindow(): ", "Error: Please allow Dll calls.");
         return (Err);
      }
      
      if (PostMessageA(WinHandle,WM_COMMAND,CHART_CMD_UPDATE_DATA,0) == 0)       //PostMessage failed, chart window closed       
            WinHandle = 0;
      else //PostMessage succeed
         return (OK);

   }
   //window not found or PostMessage failed
   return (Err);
}


